--
-- new spraytype, texture and function by TF 2020 MODS
-- help to register new fillTypes by Wopster/derelky
--
-- version 1.1.0.0

-- Changelog 1.1.0.0 - Date: 2021-03-26

-- Now only sales points that accept sugarbeets AND wheat are equipped with compost.

local modDirectory = g_currentModDirectory

function onLoadMapFinished(mission, node)

    if node ~= 0 then

        local priceMANURE = g_fillTypeManager:getFillTypeByName("MANURE").pricePerLiter

        local compostHudFile = "textures/hud_fill_compost.png"

        local compostHeapDiffuse = Utils.getFilename("textures/compost_diffuse.png", modDirectory)
        local compostHeapNormal = Utils.getFilename("$data/fillPlanes/manure_normal.dds", modDirectory)
        local compostHeapDistance = Utils.getFilename("$data/fillPlanes/distance/sunflowerDistance_diffuse.dds", modDirectory)

        print("Register filltype: COMPOST");
        local compostFillType = g_fillTypeManager:addFillType("COMPOST", g_i18n:getText("fillType_COMPOST"), true, priceMANURE * 6, 0.001, math.rad(5), compostHudFile, compostHudFile, modDirectory, nil, { 1, 1, 1 }, nil, false)
        local compostSprayType = g_sprayTypeManager:addSprayType ("COMPOST", 0.2, "FERTILIZER", 1, isBaseType)

        local compostHeightType = g_densityMapHeightManager:addDensityMapHeightType("COMPOST", math.rad(38), 1, 0.2, 0.2, 0.5, 1, true, compostHeapDiffuse, compostHeapNormal, compostHeapDistance, false)

        loadI3DFile(modDirectory .. "materialholder/compost_Fillplane_Materialholder.i3d");
        -- loadI3DFile(modDirectory .. "materialholder/compost_Particle_MaterialHolder.i3d");
        loadI3DFile(modDirectory .. "materialholder/compost_Effect_Materialholder.i3d");

        local compostCategory = {"BULK", "TRAINWAGON", "MANURESPREADER"}
        for _,x in pairs(compostCategory) do
            g_fillTypeManager:addFillTypeToCategory(compostFillType.index, g_fillTypeManager.nameToCategoryIndex[x])
        end

        g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager)

    end

end

function load(id, xmlFile, key,customEnvironment)
        local hasBarley =false
        local hasCanola =false
        local hasWheat =false
        local hasCompost=false
        local object=id
        if object == nil then
        else
        hasSugarbeet =false
        hasWheat =false
        hasCompost=false
            for i,filltype in pairs(object.acceptedFillTypes) do

            local fillname=g_fillTypeManager.indexToName[i]

                if fillname == "BARLEY" then
                    hasBarley=true
                end;
                if fillname == "CANOLA" then
                    hasCanola=true
                end;
                if fillname == "WHEAT" then
                    hasWheat=true
                end;
                if fillname == "COMPOST" then
                    hasCompost=true
                end;
            end;

                if (hasBarley and hasWheat and hasCanola) and not hasCompost then
                    local filltypes = g_fillTypeManager:getFillTypeIndexByName("COMPOST")
                    local price = g_fillTypeManager:getFillTypeByName("COMPOST").pricePerLiter
                    object:addAcceptedFillType(filltypes,price,true,false)
                    object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("COMPOST")]=object.priceMultipliers[ g_fillTypeManager:getFillTypeIndexByName("WHEAT")]
                    object:initPricingDynamics()
                end;
        end
end

FSBaseMission.loadMapFinished = Utils.prependedFunction(FSBaseMission.loadMapFinished, onLoadMapFinished)
SellingStation.load = Utils.appendedFunction(SellingStation.load, load)
